/**
 */
package FeatureCompletionModel.provider;


import FeatureCompletionModel.FeatureCompletion;
import FeatureCompletionModel.FeatureCompletionFactory;
import FeatureCompletionModel.FeatureCompletionPackage;

import java.util.Collection;
import java.util.List;

import org.eclipse.emf.common.notify.AdapterFactory;
import org.eclipse.emf.common.notify.Notification;

import org.eclipse.emf.ecore.EStructuralFeature;

import org.eclipse.emf.edit.provider.ComposeableAdapterFactory;
import org.eclipse.emf.edit.provider.IItemPropertyDescriptor;
import org.eclipse.emf.edit.provider.ViewerNotification;

/**
 * This is the item provider adapter for a {@link FeatureCompletionModel.FeatureCompletion} object.
 * <!-- begin-user-doc -->
 * <!-- end-user-doc -->
 * @generated
 */
public class FeatureCompletionItemProvider extends DescribedElementItemProvider {
	/**
	 * This constructs an instance from a factory and a notifier.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public FeatureCompletionItemProvider(AdapterFactory adapterFactory) {
		super(adapterFactory);
	}

	/**
	 * This returns the property descriptors for the adapted class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public List<IItemPropertyDescriptor> getPropertyDescriptors(Object object) {
		if (itemPropertyDescriptors == null) {
			super.getPropertyDescriptors(object);

			addFeatureObjectivesPropertyDescriptor(object);
		}
		return itemPropertyDescriptors;
	}

	/**
	 * This adds a property descriptor for the Feature Objectives feature.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected void addFeatureObjectivesPropertyDescriptor(Object object) {
		itemPropertyDescriptors.add
			(createItemPropertyDescriptor
				(((ComposeableAdapterFactory)adapterFactory).getRootAdapterFactory(),
				 getResourceLocator(),
				 getString("_UI_FeatureCompletion_featureObjectives_feature"),
				 getString("_UI_PropertyDescriptor_description", "_UI_FeatureCompletion_featureObjectives_feature", "_UI_FeatureCompletion_type"),
				 FeatureCompletionPackage.Literals.FEATURE_COMPLETION__FEATURE_OBJECTIVES,
				 true,
				 false,
				 true,
				 null,
				 null,
				 null));
	}

	/**
	 * This specifies how to implement {@link #getChildren} and is used to deduce an appropriate feature for an
	 * {@link org.eclipse.emf.edit.command.AddCommand}, {@link org.eclipse.emf.edit.command.RemoveCommand} or
	 * {@link org.eclipse.emf.edit.command.MoveCommand} in {@link #createCommand}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Collection<? extends EStructuralFeature> getChildrenFeatures(Object object) {
		if (childrenFeatures == null) {
			super.getChildrenFeatures(object);
			childrenFeatures.add(FeatureCompletionPackage.Literals.FEATURE_COMPLETION__COMPLETION_COMPONENTS);
			childrenFeatures.add(FeatureCompletionPackage.Literals.FEATURE_COMPLETION__COMPLEMENTA);
			childrenFeatures.add(FeatureCompletionPackage.Literals.FEATURE_COMPLETION__ARCHITECTURE_CONSTRAINTS);
		}
		return childrenFeatures;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	protected EStructuralFeature getChildFeature(Object object, Object child) {
		// Check the type of the specified child object and return the proper feature to use for
		// adding (see {@link AddCommand}) it as a child.

		return super.getChildFeature(object, child);
	}

	/**
	 * This returns FeatureCompletion.gif.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Object getImage(Object object) {
		return overlayImage(object, getResourceLocator().getImage("full/obj16/FeatureCompletion"));
	}

	/**
	 * This returns the label text for the adapted class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public String getText(Object object) {
		String label = ((FeatureCompletion)object).getName();
		return label == null || label.length() == 0 ?
			getString("_UI_FeatureCompletion_type") :
			getString("_UI_FeatureCompletion_type") + " " + label;
	}


	/**
	 * This handles model notifications by calling {@link #updateChildren} to update any cached
	 * children and by creating a viewer notification, which it passes to {@link #fireNotifyChanged}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void notifyChanged(Notification notification) {
		updateChildren(notification);

		switch (notification.getFeatureID(FeatureCompletion.class)) {
			case FeatureCompletionPackage.FEATURE_COMPLETION__COMPLETION_COMPONENTS:
			case FeatureCompletionPackage.FEATURE_COMPLETION__COMPLEMENTA:
			case FeatureCompletionPackage.FEATURE_COMPLETION__ARCHITECTURE_CONSTRAINTS:
				fireNotifyChanged(new ViewerNotification(notification, notification.getNotifier(), true, false));
				return;
		}
		super.notifyChanged(notification);
	}

	/**
	 * This adds {@link org.eclipse.emf.edit.command.CommandParameter}s describing the children
	 * that can be created under this object.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	protected void collectNewChildDescriptors(Collection<Object> newChildDescriptors, Object object) {
		super.collectNewChildDescriptors(newChildDescriptors, object);

		newChildDescriptors.add
			(createChildParameter
				(FeatureCompletionPackage.Literals.FEATURE_COMPLETION__COMPLETION_COMPONENTS,
				 FeatureCompletionFactory.eINSTANCE.createCompletionComponent()));

		newChildDescriptors.add
			(createChildParameter
				(FeatureCompletionPackage.Literals.FEATURE_COMPLETION__COMPLEMENTA,
				 FeatureCompletionFactory.eINSTANCE.createComplementum()));

		newChildDescriptors.add
			(createChildParameter
				(FeatureCompletionPackage.Literals.FEATURE_COMPLETION__COMPLEMENTA,
				 FeatureCompletionFactory.eINSTANCE.createComplementumVisnetis()));

		newChildDescriptors.add
			(createChildParameter
				(FeatureCompletionPackage.Literals.FEATURE_COMPLETION__ARCHITECTURE_CONSTRAINTS,
				 FeatureCompletionFactory.eINSTANCE.createArchitectureConstraints()));
	}

}
